import pygame
import sys
from button import myButton

import math

def consumer(index):
    print('Current index : %s' % index)


class TheoryScreen():
    def __init__(self, app, window_size):
        self.app = app
        self.screen = app.screen
        self.bg_color = (255, 255, 255)
        self.width, self.length = window_size
        self.font = 'corbel'
        self.little_font = pygame.font.SysFont(self.font, self.length // 30)
        self.middle_font = pygame.font.SysFont(self.font, self.length // 27, bold=True)
        self.big_font = pygame.font.SysFont(self.font, self.length // 22)

        self.buttons = []
        self.pictures_positions = []
        self.pictures = []
        self.text_positions = []
        self.strings_surfaces = []
        self.strings = []
        self.scroll = 0
        self.down_flag = True
        self.up_flag = True
        self.index = 0

        self.create_menu_items(app)

    def _update_screen(self):
        # i = 0
        # while (i < self.tiles):
        #     self.screen.blit(self.bg, (0, self.bg.get_height() * i + self.scroll))
        #     i += 1
        self.screen.blit(self.bg, (0, self.scroll))
        if self.scroll < -self.bg.get_height() + self.length:
            self.down_flag = False
        else:
            self.down_flag = True

        if self.scroll > -self.step:
            self.up_flag = False
        else:
            self.up_flag = True

        for button in self.buttons:
            button.draw_button()

    def _check_events(self):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN:
                mouse_position = pygame.mouse.get_pos()
                self._check_buttons(mouse_position)

    def _check_buttons(self, mouse_position):
        for index, button in enumerate(self.buttons):
            if button.rect.collidepoint(mouse_position):
                if index == 0:
                    self.app.active_screen = self.app.menu_screen
                elif index == 1:
                    if self.down_flag:
                        self.scroll -= self.step
                elif index == 2:
                    if self.up_flag:
                        self.scroll += self.step

    def create_menu_items(self, app):
        self.bg = pygame.image.load("sources/theory.jpg").convert_alpha()
        self.bg = pygame.transform.scale(
            self.bg, (self.width,
                      self.bg.get_height() / self.bg.get_width() * self.width))
        #self.bg = pygame.transform.rotate(self.bg, 180)
        self.tiles = math.ceil(self.length / self.bg.get_height()) + 1
        self.step = self.bg.get_height() // 20

        pos = 23 * self.width // 24
        button_size = (self.width // 15, self.length // 17)
        button_size2 = (self.length // 17, self.length // 17)
        button_pos = (pos - button_size[0]//2, 22 * self.length // 24)
        button_pos2 = (pos - button_size2[0] // 2, 22 * self.length // 24 - self.length // 17 - self.length // 24)
        button_pos3 = (pos - button_size2[0] // 2, 22 * self.length // 24 - 2 * self.length // 17 - 1.5 * self.length // 24)

        self.buttons = [myButton(app, "Назад", button_pos, button_size),
                        myButton(app, "v", button_pos2, button_size2),
                        myButton(app, "^", button_pos3, button_size2)]